<script setup lang="ts">

import {useStockStore} from "@/stores/stock"
import { useAuthStore } from "@/stores/auth";
import PrintDialog from "./PrintDialog.vue";

import { onMounted, ref } from "vue";



const stockStore = useStockStore()
const authStore = useAuthStore()

const currentDate = ref()
const currentTime = ref()
const now = new Date();
const time = new Date().toLocaleTimeString()
const  headers =[
          {
        
            key: 'id',
            sortable: false,
            title: 'ProuductId',
          },
          { key: 'name', title: 'ProuductName',sortable: false },
          { key: 'minimum', title: 'Minimum',sortable: false },
          { key: 'balance', title: 'Balance',sortable: false },
          { key: 'unit', title: 'Unit',sortable: false  },
          { title: 'Amount', key: 'amount', sortable: false },
        ]

const setupDateAndTime = () => {
  currentDate.value = `${now.getDate()}/${now.getMonth() + 1}/${now.getFullYear()}`;
  currentTime.value = `${time}:${now.getMinutes()}`;
};

onMounted(() => {
  setupDateAndTime();
});
const blc = ref()
function changeBl(){
  const paInt = blc.value = parseInt(blc.value, 10);
  let bl = stockStore.editedSProduct.balance = paInt
  stockStore.editedSProduct.balance = bl 
  clearTxtField()
}
const notifications = ref(false)
const sound = ref(false)
const widgets = ref(false)
function clearTxtField(){
    blc.value =0
}
function validateNumber(value:any) {
    const isValid = /^\d+$/.test(value);
    return isValid || "Please enter a number";
}
function save(){
  stockStore.logStupid

}
</script>
<template>
   
   <v-dialog
      v-model="stockStore.dialogCheckStock"
      fullscreen
      :scrim="false"
      transition="dialog-bottom-transition"
    >
      <v-card>
        <v-toolbar
          dark
          color="primary"
        >
          <v-btn
            icon
            dark
            @click="stockStore.dialogCheckStock = !stockStore.dialogCheckStock"
          >
            <v-icon>mdi-close</v-icon>
          </v-btn>
          <v-toolbar-title>Check Stock</v-toolbar-title>
          <v-spacer></v-spacer>
          
        </v-toolbar>
        
       <v-container>
         <v-row>
          <v-sheet  width="1300" height="120" >
        <div>ผู้ตรวจนับ:{{authStore.currentUser?.fullname}}</div>
        <div>วันที่:{{currentDate}} เวลา {{currentTime}}</div>
        </v-sheet>

        </v-row >
         <v-row no-gutters>
          <v-sheet width="1250" height="500" class="overflow-auto" >
            <div style="font-size: 20pt; text-align: center;">Check Stock</div>
            <v-data-table 
            :headers="headers"
            :items="stockStore.stockItems"
            
            >
            <template v-slot:[`item.amount`]="{ item }">
                 <v-text-field
                 density="compact" 
                 inputmode="numeric" 
                 pattern="[0-9]*"
                 
                 type="number"
                 v-model="stockStore.listCheck[item.id-1]"
                 append-inner-icon="mdi-send" 
                 @click:append-inner="changeBl"
                 @key.enter="changeBl" 
                 :rules="[validateNumber]"
                >
               
                 </v-text-field>
    </template>
    
            </v-data-table>
          </v-sheet>
             <v-row no-gutters>
          <v-col cols="6" style="padding-top: 0px;" > <div><v-btn prepend-icon="" style="margin-left: 900px;" @click="stockStore.logIntplus" >Save</v-btn></div></v-col>
          <v-col cols="6" style="padding-top: 0px;" > <div><v-btn prepend-icon="" style="margin-left: 220px;" @click="stockStore.openPrint">Print</v-btn></div></v-col>
        </v-row>
         </v-row> 
         
       </v-container>
       
       
      </v-card>
    </v-dialog>
    <print-dialog></print-dialog>

</template>
<style>
.dialog-bottom-transition-enter-active,
.dialog-bottom-transition-leave-active {
  transition: transform .2s ease-in-out;
}
</style>